var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") return Reflect.decorate(decorators, target, key, desc);
    switch (arguments.length) {
        case 2: return decorators.reduceRight(function(o, d) { return (d && d(o)) || o; }, target);
        case 3: return decorators.reduceRight(function(o, d) { return (d && d(target, key)), void 0; }, void 0);
        case 4: return decorators.reduceRight(function(o, d) { return (d && d(target, key, o)) || o; }, desc);
    }
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require("angular2/core");
var InfiniteScroller = (function () {
    function InfiniteScroller(element) {
        this.next = new core_1.EventEmitter();
        this.prev = new core_1.EventEmitter();
        this.container = element.nativeElement;
    }
    InfiniteScroller.prototype.ngAfterContentInit = function () {
        var _this = this;
        this.contentQuery.changes
            .subscribe(function () { return _this.contentQuery.map(function (i) { return console.log(_this); }); });
    };
    InfiniteScroller.prototype.registerItems = function () {
    };
    InfiniteScroller.prototype.doscroll = function (event) {
        var target = (typeof event.srcElement === 'undefined' ? event.target : event.srcElement);
        var height = target.getBoundingClientRect().height;
        if (height - target.scrollTop > 100)
            return;
        console.log(this.contentQuery);
        //console.log(this.itemQuery);
        //console.log(this.itemQuery.first.element.getBoundingClientRect().top);
        this.next.emit(null);
    };
    InfiniteScroller.prototype.isVisable = function (item) {
        var containerRect = this.container.getBoundingClientRect();
        var itemRect = item.element.getBoundingClientRect();
        return itemRect.top < containerRect.height;
    };
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Number)
    ], InfiniteScroller.prototype, "distance");
    __decorate([
        core_1.Output(), 
        __metadata('design:type', Object)
    ], InfiniteScroller.prototype, "next");
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_1.EventEmitter)
    ], InfiniteScroller.prototype, "prev");
    __decorate([
        core_1.ContentChildren(InfiniteScrollItem), 
        __metadata('design:type', core_1.QueryList)
    ], InfiniteScroller.prototype, "contentQuery");
    InfiniteScroller = __decorate([
        core_1.Component({
            selector: 'infinite-scroller'
        }),
        core_1.View({
            template: "\n\t\t<div class=\"scroll-container\" (scroll)=\"doscroll($event)\">\n\t\t\t<ng-content></ng-content>\n\t\t</div>\n\t",
            styles: ["\n\t\t.scroll-container {\n\t\t\toverflow-y: scroll;\n\t\t\toverflow-x: hidden;\n\t\t\theight: 300px;\n\t\t}\n\t\t\n\t\t.scroll-container::-webkit-scrollbar {\n\t\t\tdisplay: none;\n\t\t}\n\t\t\n\t\t.scroll-content {\n\t\t\toverflow: auto;\n\t\t}\n\t"]
        }), 
        __metadata('design:paramtypes', [core_1.ElementRef])
    ], InfiniteScroller);
    return InfiniteScroller;
})();
exports.InfiniteScroller = InfiniteScroller;
var InfiniteScrollItem = (function () {
    function InfiniteScrollItem(element) {
        this.element = element.nativeElement;
        //console.log(this);
    }
    InfiniteScrollItem = __decorate([
        core_1.Directive({
            selector: '[infinite-scroll-item]'
        }), 
        __metadata('design:paramtypes', [core_1.ElementRef])
    ], InfiniteScrollItem);
    return InfiniteScrollItem;
})();
exports.InfiniteScrollItem = InfiniteScrollItem;
exports.InfiniteScrollerProviders = [
    InfiniteScroller,
    InfiniteScrollItem
];

//# sourceMappingURL=InfiniteScroller.js.map
